//*****************************************************************************
//* Copyright (c) 2002-2004 Miday Workshop All rights reserved.
//*
//* File: DefMain.h
//*****************************************************************************

//\  (Struct)
extern OPTIONS2 Opt2;
extern OPTIONS3 Opt3, Opt3p;
extern COLOR_DEF Color_def[Max_Color_no];
extern BEAM_HEADER Beam_hd;

extern FormPtr  frm;
extern ListType *lstTable;
extern unsigned short cardNo;

//gK[p̗̈  (The domain for triggers.  Start)
extern short Year_no;
extern short Month_no;

extern char Start_Year_data[10][7], *Start_Year_table[10], Start_Month_data[12][5], *Start_Month_table[12];
extern char End_Year_data[10][7],   *End_Year_table[10],   End_Month_data[12][5],   *End_Month_table[12];

extern char memorial1_Year_data[11][7],  *memorial1_Year_table[11];
extern char memorial1_Month_data[12][5], *memorial1_Month_table[12];
extern char memorial1_Day_data[31][5],   *memorial1_Day_table[31];
extern short memorial1_Day_no;

extern char memorial2_Year_data[11][7],  *memorial2_Year_table[11];
extern char memorial2_Month_data[12][5], *memorial2_Month_table[12];
extern char memorial2_Day_data[31][5],   *memorial2_Day_table[31];
extern short memorial2_Day_no;

extern char memorial3_Year_data[11][7],  * memorial3_Year_table[11];
extern char memorial3_Month_data[12][5], * memorial3_Month_table[12];
extern char memorial3_Day_data[31][5],   * memorial3_Day_table[31];
extern short memorial3_Day_no;

extern char memorial4_Year_data[11][7],  *memorial4_Year_table[11];
extern char memorial4_Month_data[12][5], *memorial4_Month_table[12];
extern char memorial4_Day_data[31][5],   *memorial4_Day_table[31];
extern short memorial4_Day_no;

extern char Beam_Start_Year_data[10][7], *Beam_Start_Year_table[10], Beam_Start_Month_data[12][5], *Beam_Start_Month_table[12];
extern char Beam_End_Year_data[10][7],   *Beam_End_Year_table[10],   Beam_End_Month_data[12][5],   *Beam_End_Month_table[12];

extern char Color_data[Max_Color_no+2][9],   *Color_table[Max_Color_no+2];
extern char Color_w_data[Max_Color_no+2][9], *Color_w_table[Max_Color_no+2];
extern char Color_h_data[Max_Color_no+2][9], *Color_h_table[Max_Color_no+2];
//gK[p̗̈  ܂  (The domain for triggers.  End)

//Ff[^x[XgK[p̗̈    (The domain for color database triggers.  Start)
extern char Trigger_file_data[20][10];
extern char* Trigger_file_table[20];
extern short Trigger_file_no;
extern char trigger_file_title[100];
//Ff[^x[XgK[p̗̈  ܂  (The domain for color database triggers.  End)

//Ff[^x[Xt@C    (Color database file information.  Start)
extern char Col_file[Max_Color_File_no][20];
extern short Col_data_no;
extern LocalID Col_dbIDP[Max_Color_File_no];
//Ff[^x[Xt@C  ܂  (Color database file information.  End)


extern short Color_no;
extern short Color_dev_type;

extern short OS_Color_Support;
extern short OS_Ver_no;
extern short Lang;

extern char ColorDefString[20], ColorNormalString[20], WeekString[20], HolDefString[20];
extern char Monthname[61], Weekname[15], Year_suffix[10], Month_suffix[10], Day_suffix[10];

extern short Back_md_flag, Back_me_flag;

extern short Max_over_color_flag, Max_over_text_flag;

extern short Color_win_max_color;

extern short Color_call_win;

extern short Stop_flag;
extern short MainWinRedraw;
extern short Dataupdateflag;

extern short Yasumi_no, Yasumi_max_no;
extern short Sv_st_year, Sv_st_month, Sv_en_year, Sv_en_month, Sv_month_no;

extern short Start_year;
extern short Cu_Year, Cu_Month;

extern MemHandle Yasumi_mem_hndl;

extern unsigned char Yasumi_dis[4][31];
extern short Yasumi_year_dis[4], Yasumi_month_dis[4], Yasumi_no_dis[4];

extern unsigned char Color_table_bit[Max_Color_no];

extern short Beam_trnce_flag;
extern MemHandle      BeamMemH;

extern short Bluetooth_libflag;

extern DY_PREFDATA Dy_PrefGetData, Dy_PrefSetData;


//֐̃vg^Cv錾  (The prototype of a function.)
//Commin.c
extern void GetPreferences();
extern void SetColorFileCategory(short CategoryList, short CategoryTrigger, short Button);
extern short GetDayOfTheWeek(short year, short month, short *day_no);
extern void mono1e(short x, short y);
extern void mono2(short x, short y, short no, short type_no);
extern void ColorList (short index, RectangleType *boundsP, short max_no, short col_data_no);
extern void ColorRectDisp2 (short ia, RectangleType r_col);
extern void *GetObjectPtr (unsigned short objectID);

//ComminDB.c
//Version 3.2 Add Start
extern void file_name_change();
//Version 3.2 Add End
extern void ColorFileNameGet();
extern short FileCheck(short flag, char *file_check);
extern short GetRedBeamData(short all_flag, short *start_year, short *start_month, short *end_year, short *end_month, unsigned long *standard_data, short *no);
extern short DeleteRedDataOfArray(short start_year, short start_month, short end_year, short end_month);
extern short RsetRedDataOfArray(short color1, short color2);
extern void GetRedDataOfArray(short year, short month, unsigned char *red, short *no);
extern short SetRedDataOfArray(short year, short month, unsigned char *red, short no);
extern void RedData_Compresses(short save_color, unsigned char *local_data, unsigned long *standard_data, short *flag);
extern void RedData_Extends(short save_color, unsigned char *local_data, unsigned long *standard_data);
extern void Md_InitRedDate(short no);
extern void Md_GetDatabase(short flag, char *file_name);
extern short Md_SetDatabase(short flag, char *file_name);

//get_hol.c
extern void GetHoliday( short year, short month, short *sai_no, short sai_day[] );

//Beam.c
extern void ReceiveData(ExgSocketPtr exgSocketP);
extern void ReceiveDataBackup(unsigned char *MemP);

//CxgnhO  (Event handling.)
extern Boolean MainWinHandleEvent (EventType * event);
extern Boolean ModelHandleEvent (EventType * event);
extern Boolean MemorialWinHandleEvent (EventType * event);
extern Boolean ColorDefineHandleEvent (EventType * event);
extern Boolean PreferencesHandleEvent (EventType * event);
extern Boolean ToolsHandleEvent (EventType * event);
extern Boolean BeamWinHandleEvent (EventType * event);
extern Boolean AboutHandleEvent (EventType * event);
